diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayBySerial.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayBySerial.java
index 1c9838f834a473b42370fb61fa3e19016936f1f7..36746106a70cd05bf453572c2b363f43236b067e 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayBySerial.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DisplayBySerial.java
@@ -309,8 +309,8 @@ public class DisplayBySerial extends CMSServlet {
                     String rid = (String) metaInfo.get(ICertRecord.META_REQUEST_ID);
 
                     if (rid != null && mAuthority instanceof ICertificateAuthority) {
-                        IRequest r = ((ICertificateAuthority) mAuthority).getRequestQueue().findRequest(
-                                new RequestId(rid));
+                        IRequest r =
+                                ((ICertificateAuthority) mAuthority).getRequestQueue().findRequest(new RequestId(rid));
                         String certType = r.getExtDataInString(IRequest.HTTP_PARAMS, IRequest.CERT_TYPE);
 
                         if (certType != null && certType.equals(IRequest.CLIENT_CERT)) {
@@ -331,7 +331,7 @@ public class DisplayBySerial extends CMSServlet {
                 CRLExtensions crlExts = revocationInfo.getCRLEntryExtensions();
 
                 if (crlExts != null) {
-                    Enumeration enumx = crlExts.getElements();
+                    Enumeration<Extension> enumx = crlExts.getElements();
                     int reason = 0;
 
                     while (enumx.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java
index 97a70fac3c33386d2b403995e0c51b6d2097d02c..b84f5ace14ba8abe694a76793ebe00a0632a982e 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevoke.java
@@ -439,8 +439,8 @@ public class DoRevoke extends CMSServlet {
 
         try {
             int count = 0;
-            Vector oldCertsV = new Vector();
-            Vector revCertImplsV = new Vector();
+            Vector<X509CertImpl> oldCertsV = new Vector<X509CertImpl>();
+            Vector<RevokedCertImpl> revCertImplsV = new Vector<RevokedCertImpl>();
 
             // Construct a CRL reason code extension.
             RevocationReason revReason = RevocationReason.fromInt(reason);
@@ -465,11 +465,11 @@ public class DoRevoke extends CMSServlet {
 
             if (mAuthority instanceof ICertificateAuthority) {
 
-                Enumeration e = mCertDB.searchCertificates(revokeAll,
+                Enumeration<ICertRecord> e = mCertDB.searchCertificates(revokeAll,
                         totalRecordCount, mTimeLimits);
 
                 while (e != null && e.hasMoreElements()) {
-                    ICertRecord rec = (ICertRecord) e.nextElement();
+                    ICertRecord rec = e.nextElement();
 
                     if (rec == null)
                         continue;
@@ -532,7 +532,7 @@ public class DoRevoke extends CMSServlet {
 
             } else if (mAuthority instanceof IRegistrationAuthority) {
                 String reqIdStr = req.getParameter("requestId");
-                Vector serialNumbers = new Vector();
+                Vector<String> serialNumbers = new Vector<String>();
 
                 if (revokeAll != null && revokeAll.length() > 0) {
                     for (int i = revokeAll.indexOf('='); i < revokeAll.length() && i > -1; 
@@ -787,8 +787,8 @@ public class DoRevoke extends CMSServlet {
                                             "completed",
                                             cert.getSubjectDN(),
                                             cert.getSerialNumber().toString(16),
-                                            RevocationReason.fromInt(reason).toString() + " time: "
-                                                    + (endTime - startTime) }
+                                            RevocationReason.fromInt(reason).toString()
+                                                    + " time: " + (endTime - startTime) }
                                     );
                         }
                     }
@@ -833,7 +833,7 @@ public class DoRevoke extends CMSServlet {
 
                 if (mAuthority instanceof ICertificateAuthority) {
                     // let known update and publish status of all crls. 
-                    Enumeration otherCRLs =
+                    Enumeration<ICRLIssuingPoint> otherCRLs =
                             ((ICertificateAuthority) mAuthority).getCRLIssuingPoints();
 
                     while (otherCRLs.hasMoreElements()) {
@@ -925,7 +925,7 @@ public class DoRevoke extends CMSServlet {
                 } else {
                     header.addStringValue("revoked", "no");
                 }
-                Vector errors = revReq.getExtDataInStringVector(IRequest.ERRORS);
+                Vector<String> errors = revReq.getExtDataInStringVector(IRequest.ERRORS);
                 if (errors != null) {
                     StringBuffer errInfo = new StringBuffer();
                     for (int i = 0; i < errors.size(); i++) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java
index 075f3218b8f45b2e17e8607e347d54899aaac4a4..00cca204a98275a87f6c291923d2a5b22f1ae7f9 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/DoRevokeTPS.java
@@ -353,8 +353,8 @@ public class DoRevokeTPS extends CMSServlet {
 
         try {
             int count = 0;
-            Vector oldCertsV = new Vector();
-            Vector revCertImplsV = new Vector();
+            Vector<X509CertImpl> oldCertsV = new Vector<X509CertImpl>();
+            Vector<RevokedCertImpl> revCertImplsV = new Vector<RevokedCertImpl>();
 
             // Construct a CRL reason code extension.
             RevocationReason revReason = RevocationReason.fromInt(reason);
@@ -377,7 +377,7 @@ public class DoRevokeTPS extends CMSServlet {
                 entryExtn.set(invalidityDateExtn.getName(), invalidityDateExtn);
             }
 
-            Enumeration e = mCertDB.searchCertificates(revokeAll,
+            Enumeration<ICertRecord> e = mCertDB.searchCertificates(revokeAll,
                     totalRecordCount, mTimeLimits);
 
             boolean alreadyRevokedCertFound = false;
@@ -593,8 +593,8 @@ public class DoRevokeTPS extends CMSServlet {
                                             "completed",
                                             cert.getSubjectDN(),
                                             cert.getSerialNumber().toString(16),
-                                            RevocationReason.fromInt(reason).toString() + " time: "
-                                                    + (endTime - startTime) }
+                                            RevocationReason.fromInt(reason).toString()
+                                                    + " time: " + (endTime - startTime) }
                                     );
                         }
                     }
@@ -633,7 +633,7 @@ public class DoRevokeTPS extends CMSServlet {
 
                 if (mAuthority instanceof ICertificateAuthority) {
                     // let known update and publish status of all crls. 
-                    Enumeration otherCRLs =
+                    Enumeration<ICRLIssuingPoint> otherCRLs =
                             ((ICertificateAuthority) mAuthority).getCRLIssuingPoints();
 
                     while (otherCRLs.hasMoreElements()) {
@@ -718,7 +718,7 @@ public class DoRevokeTPS extends CMSServlet {
                     o_status = "status=2";
                     errorString = "error=Undefined request status";
                 }
-                Vector errors = revReq.getExtDataInStringVector(IRequest.ERRORS);
+                Vector<String> errors = revReq.getExtDataInStringVector(IRequest.ERRORS);
                 if (errors != null) {
                     StringBuffer errInfo = new StringBuffer();
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
index 0c7b73780b99a1bc00976243fa9fe10e3a50fad0..7b3fb2f748d236f7fe34d3ad2a47ac12c83aa6dc 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/EnrollServlet.java
@@ -465,12 +465,13 @@ public class EnrollServlet extends CMSServlet {
         }
 
         String filter =
-                "(&(x509cert.subject=" + certBasedOldSubjectDN + ")(!(x509cert.serialNumber=" + certBasedOldSerialNum
+                "(&(x509cert.subject="
+                        + certBasedOldSubjectDN + ")(!(x509cert.serialNumber=" + certBasedOldSerialNum
                         + "))(certStatus=VALID))";
         ICertRecordList list =
                 (ICertRecordList) mCa.getCertificateRepository().findCertRecordsInList(filter, null, 10);
         int size = list.getSize();
-        Enumeration en = list.getCertRecords(0, size - 1);
+        Enumeration<ICertRecord> en = list.getCertRecords(0, size - 1);
         boolean gotEncCert = false;
 
         CMS.debug("EnrollServlet: signing cert filter " + filter);
@@ -572,10 +573,10 @@ public class EnrollServlet extends CMSServlet {
             // audit log the status
             try {
                 if (status == RequestStatus.REJECTED) {
-                    Vector messages = req.getExtDataInStringVector(IRequest.ERRORS);
+                    Vector<String> messages = req.getExtDataInStringVector(IRequest.ERRORS);
 
                     if (messages != null) {
-                        Enumeration msgs = messages.elements();
+                        Enumeration<String> msgs = messages.elements();
                         StringBuffer wholeMsg = new StringBuffer();
 
                         while (msgs.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
index e42150f878d1915c0c72abe9218440ff9932e3d0..4d5b711c049520eed21044ecb6fb8d12fbf2e097 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/HashEnrollServlet.java
@@ -487,13 +487,14 @@ public class HashEnrollServlet extends CMSServlet {
                 }
 
                 String filter =
-                        "(&(x509cert.subject=" + certBasedOldSubjectDN + ")(!(x509cert.serialNumber="
-                                + certBasedOldSerialNum + "))(certStatus=VALID))";
+                        "(&(x509cert.subject="
+                                + certBasedOldSubjectDN + ")(!(x509cert.serialNumber=" + certBasedOldSerialNum
+                                + "))(certStatus=VALID))";
                 ICertRecordList list =
                         (ICertRecordList) mCa.getCertificateRepository().findCertRecordsInList(filter,
                                 null, 10);
                 int size = list.getSize();
-                Enumeration en = list.getCertRecords(0, size - 1);
+                Enumeration<ICertRecord> en = list.getCertRecords(0, size - 1);
                 boolean gotEncCert = false;
 
                 if (!en.hasMoreElements()) {
@@ -656,10 +657,10 @@ public class HashEnrollServlet extends CMSServlet {
             // audit log the status 
             try {
                 if (status == RequestStatus.REJECTED) {
-                    Vector messages = req.getExtDataInStringVector(IRequest.ERRORS);
+                    Vector<String> messages = req.getExtDataInStringVector(IRequest.ERRORS);
 
                     if (messages != null) {
-                        Enumeration msgs = messages.elements();
+                        Enumeration<String> msgs = messages.elements();
                         StringBuffer wholeMsg = new StringBuffer();
 
                         while (msgs.hasMoreElements()) {
@@ -947,8 +948,8 @@ public class HashEnrollServlet extends CMSServlet {
                 // field suggested notBefore and notAfter in CRMF
                 // Tech Support #383184
                 if (certTemplate.getNotBefore() != null || certTemplate.getNotAfter() != null) {
-                    CertificateValidity certValidity = new CertificateValidity(certTemplate.getNotBefore(),
-                            certTemplate.getNotAfter());
+                    CertificateValidity certValidity =
+                            new CertificateValidity(certTemplate.getNotBefore(), certTemplate.getNotAfter());
 
                     certInfo.set(X509CertInfo.VALIDITY, certValidity);
                 }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java b/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
index c12c8193d730e58315b4a85ca4addee206c3f37c..8a818f5e819c4d42f31f6867ddbba86c32916539 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/ListCerts.java
@@ -68,10 +68,8 @@ public class ListCerts extends CMSServlet {
      */
     private static final long serialVersionUID = -3568155814023099576L;
     private final static String TPL_FILE = "queryCert.template";
-    private final static String INFO = "ListCerts";
     private final static BigInteger MINUS_ONE = new BigInteger("-1");
 
-    private final static String CURRENT_TIME = "currentTime";
     private final static String USE_CLIENT_FILTER = "useClientFilter";
     private final static String ALLOWED_CLIENT_FILTERS = "allowedClientFilters";
 
@@ -82,7 +80,7 @@ public class ListCerts extends CMSServlet {
     private boolean mHardJumpTo = false; //jump to the end
     private String mDirection = null;
     private boolean mUseClientFilter = false;
-    private Vector mAllowedClientFilters = new Vector();
+    private Vector<String> mAllowedClientFilters = new Vector<String>();
     private int mMaxReturns = 2000;
 
     /**
@@ -149,18 +147,18 @@ public class ListCerts extends CMSServlet {
 
         if (mUseClientFilter) {
             com.netscape.certsrv.apps.CMS.debug("useClientFilter=true");
-            Enumeration filters = mAllowedClientFilters.elements();
+            Enumeration<String> filters = mAllowedClientFilters.elements();
             // check to see if the filter is allowed
             while (filters.hasMoreElements()) {
                 String filter = (String) filters.nextElement();
-                com.netscape.certsrv.apps.CMS.debug("Comparing filter=" + filter + " queryCertFilter="
-                        + queryCertFilter);
+                com.netscape.certsrv.apps.CMS.debug("Comparing filter="
+                        + filter + " queryCertFilter=" + queryCertFilter);
                 if (filter.equals(queryCertFilter)) {
                     return queryCertFilter;
                 }
             }
-            com.netscape.certsrv.apps.CMS.debug("Requested filter '" + queryCertFilter
-                    + "' is not allowed. Please check the " + ALLOWED_CLIENT_FILTERS + "parameter");
+            com.netscape.certsrv.apps.CMS.debug("Requested filter '"
+                    + queryCertFilter + "' is not allowed. Please check the " + ALLOWED_CLIENT_FILTERS + "parameter");
             return null;
         } else {
             com.netscape.certsrv.apps.CMS.debug("useClientFilter=false");
@@ -320,8 +318,9 @@ public class ListCerts extends CMSServlet {
         } catch (NumberFormatException e) {
             log(ILogger.LL_FAILURE, com.netscape.certsrv.apps.CMS.getLogMessage("BASE_INVALID_NUMBER_FORMAT"));
 
-            error = new EBaseException(com.netscape.certsrv.apps.CMS.getUserMessage(getLocale(req),
-                    "CMS_BASE_INVALID_NUMBER_FORMAT"));
+            error =
+                    new EBaseException(com.netscape.certsrv.apps.CMS.getUserMessage(getLocale(req),
+                            "CMS_BASE_INVALID_NUMBER_FORMAT"));
         } catch (EBaseException e) {
             error = e;
         }
@@ -395,7 +394,7 @@ public class ListCerts extends CMSServlet {
                 pSize);
         // retrive maxCount + 1 entries
 
-        Enumeration e = list.getCertRecords(0, maxCount);
+        Enumeration<ICertRecord> e = list.getCertRecords(0, maxCount);
 
         ICertRecordList tolist = null;
         int toCurIndex = 0;
@@ -407,7 +406,7 @@ public class ListCerts extends CMSServlet {
                         filter,
                         (String[]) null, serialTo,
                         "serialno", maxCount);
-            Enumeration en = tolist.getCertRecords(0, 0);
+            Enumeration<ICertRecord> en = tolist.getCertRecords(0, 0);
 
             if (en == null || (!en.hasMoreElements())) {
                 toCurIndex = list.getSize() - 1;
@@ -654,7 +653,7 @@ public class ListCerts extends CMSServlet {
                 CRLExtensions crlExts = revocationInfo.getCRLEntryExtensions();
 
                 if (crlExts != null) {
-                    Enumeration enum1 = crlExts.getElements();
+                    Enumeration<Extension> enum1 = crlExts.getElements();
                     int reason = 0;
 
                     while (enum1.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java b/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java
index bbe8a479efe3935d6f19cee59d007a89cd4f72dc..8e6d5821604a9d843577c438c0a9fcf4869b4b85 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/SrchCerts.java
@@ -608,14 +608,14 @@ public class SrchCerts extends CMSServlet {
                 CMS.debug("Resetting timelimit from " + timeLimit + " to " + mTimeLimits);
                 timeLimit = mTimeLimits;
             }
-            CMS.debug("Start searching ... " + "filter=" + filter + " maxreturns=" + maxResults + " timelimit="
-                    + timeLimit);
-            Enumeration e = mCertDB.searchCertificates(filter, maxResults, timeLimit);
+            CMS.debug("Start searching ... "
+                    + "filter=" + filter + " maxreturns=" + maxResults + " timelimit=" + timeLimit);
+            Enumeration<ICertRecord> e = mCertDB.searchCertificates(filter, maxResults, timeLimit);
 
             int count = 0;
 
             while (e != null && e.hasMoreElements()) {
-                ICertRecord rec = (ICertRecord) e.nextElement();
+                ICertRecord rec = e.nextElement();
 
                 if (rec != null) {
                     count++;
@@ -744,11 +744,11 @@ public class SrchCerts extends CMSServlet {
                 CRLExtensions crlExts = revocationInfo.getCRLEntryExtensions();
 
                 if (crlExts != null) {
-                    Enumeration enum1 = crlExts.getElements();
+                    Enumeration<Extension> enum1 = crlExts.getElements();
                     int reason = 0;
 
                     while (enum1.hasMoreElements()) {
-                        Extension ext = (Extension) enum1.nextElement();
+                        Extension ext = enum1.nextElement();
 
                         if (ext instanceof CRLReasonExtension) {
                             reason = ((CRLReasonExtension) ext).getReason().toInt();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java b/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java
index 9d3e633d2339480625cfa61fda53201c7c3182f0..680886b95dcfc28b69924665ee0ff86efa062856 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/UpdateCRL.java
@@ -50,6 +50,7 @@ import com.netscape.certsrv.ca.ICertificateAuthority;
 import com.netscape.certsrv.ldap.ELdapException;
 import com.netscape.certsrv.logging.AuditFormat;
 import com.netscape.certsrv.logging.ILogger;
+import com.netscape.certsrv.publish.ILdapRule;
 import com.netscape.certsrv.publish.IPublisherProcessor;
 import com.netscape.certsrv.util.IStatsSubsystem;
 import com.netscape.cms.servlet.base.CMSServlet;
@@ -72,7 +73,7 @@ public class UpdateCRL extends CMSServlet {
     private final static String INFO = "UpdateCRL";
     private final static String TPL_FILE = "updateCRL.template";
 
-    private static Vector mTesting = new Vector();
+    private static Vector<String> mTesting = new Vector<String>();
 
     private String mFormPath = null;
     private ICertificateAuthority mCA = null;
@@ -278,7 +279,7 @@ public class UpdateCRL extends CMSServlet {
         rarg.addStringValue("crlSizes", crlSizes);
 
         StringBuffer crlSplits = new StringBuffer();
-        Vector splits = crlIssuingPoint.getSplitTimes();
+        Vector<Long> splits = crlIssuingPoint.getSplitTimes();
         for (int i = 0; i < splits.size(); i++) {
             crlSplits.append(splits.elementAt(i));
             if (i + 1 < splits.size())
@@ -311,10 +312,10 @@ public class UpdateCRL extends CMSServlet {
         String results = req.getParameter("results");
 
         if (crlIssuingPointId != null) {
-            Enumeration ips = mCA.getCRLIssuingPoints();
+            Enumeration<ICRLIssuingPoint> ips = mCA.getCRLIssuingPoints();
 
             while (ips.hasMoreElements()) {
-                ICRLIssuingPoint ip = (ICRLIssuingPoint) ips.nextElement();
+                ICRLIssuingPoint ip = ips.nextElement();
 
                 if (crlIssuingPointId.equals(ip.getId())) {
                     break;
@@ -447,7 +448,7 @@ public class UpdateCRL extends CMSServlet {
                         }
 
                         if (lpm != null && lpm.enabled()) {
-                            Enumeration rules = lpm.getRules(IPublisherProcessor.PROP_LOCAL_CRL);
+                            Enumeration<ILdapRule> rules = lpm.getRules(IPublisherProcessor.PROP_LOCAL_CRL);
                             if (rules != null && rules.hasMoreElements()) {
                                 if (publishError != null) {
                                     header.addStringValue("crlPublished", "Failure");
@@ -481,8 +482,8 @@ public class UpdateCRL extends CMSServlet {
                                             crlIssuingPoint.getCRLNumber(),
                                             crlIssuingPoint.getLastUpdate(),
                                             crlIssuingPoint.getNextUpdate(),
-                                            Long.toString(crlIssuingPoint.getCRLSize()) + " time: "
-                                                    + (endTime - startTime) }
+                                            Long.toString(crlIssuingPoint.getCRLSize())
+                                                    + " time: " + (endTime - startTime) }
                                     );
                         } else {
                             mLogger.log(ILogger.EV_AUDIT, ILogger.S_OTHER,
@@ -496,8 +497,8 @@ public class UpdateCRL extends CMSServlet {
                                             crlIssuingPoint.getCRLNumber(),
                                             crlIssuingPoint.getLastUpdate(),
                                             "not set",
-                                            Long.toString(crlIssuingPoint.getCRLSize()) + " time: "
-                                                    + (endTime - startTime) }
+                                            Long.toString(crlIssuingPoint.getCRLSize())
+                                                    + " time: " + (endTime - startTime) }
                                     );
                         }
                     } catch (EBaseException e) {
